#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

int main(){
	int n;
	cin>>n;
	map<string,vector<int>>sch;
	for(int i=0;i<n;i++){
		int str;
		string school;
		cin >> school >> str >> school;
		sch[school].push_back(str);
	}
	
	vector<pair<string, vector<int>>> vsch;
	for (auto e : sch)
		if (e.second.size() > 2)
			vsch.push_back(e);
	
	vector<pair<int ,string>> ans;
	for (auto e : vsch) {
		sort(e.second.rbegin(), e.second.rend());
		int sum = 0;
		for (int i = 0; i < 3; ++i)
			sum += e.second[i];
		ans.push_back({sum, e.first});
	}
	
	sort(ans.rbegin(), ans.rend());
	
	for (auto e : ans)
		cout << e.second << endl;
	return 0;
}