#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>

using namespace std;

int main(){
	int n;
	cin>>n;
	vector<vector<int>>g(n);
	for(int i=0;i<n-1;i++){
		int x,y;
		cin>>x>>y;
		x--;y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	vector<long long> b(n);
	for(int i=0;i<n;i++)
		cin>>b[i];
	
	vector<long long> vsum(n);
	for (int v = 0; v < n; ++v)
		for (auto to : g[v])
			vsum[v] += b[to];
	
	long long ans = 0;
	for (int v = 0; v < n; ++v) {
		bool f = true;
		for (auto to : g[v])
			f &= g[to].size() > 1;
		if (!f)
			continue;
		long long sum = 0;
		for (auto to : g[v])
			sum += vsum[to];
		sum -= g[v].size() * b[v];
		ans = max(ans, sum);
	}
	
	cout << ans;
	return 0;
}