import javafx.util.Pair;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.Buffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        String[] inn = in.readLine().split(" ");
        int n = Integer.parseInt(inn[0]), m = Integer.parseInt(inn[1]);
        Pair<Long, Long>[] mas = new Pair[n];
        for(int i = 0; i < n; i++){
            inn = in.readLine().split(" ");

            long a = Integer.parseInt(inn[0]), b = Integer.parseInt(inn[1]);

            mas[i] = new Pair(a + b, (long)i+1);
        }

        Arrays.sort(mas, new Comparator<Pair<Long, Long>>() {
            @Override
            public int compare(Pair<Long, Long> o1, Pair<Long, Long> o2) {
                return o1.getKey().compareTo(o2.getKey());
            }
        });
        long ans = 0;
        ArrayList<Long> list = new ArrayList<>();
        for(int i = 0; i < m; i++){
            ans += mas[i].getKey();
            list.add(mas[i].getValue());
        }
        System.out.println(ans);

        list.sort(new Comparator<Long>() {
            @Override
            public int compare(Long o1, Long o2) {
                return o1.compareTo(o2);
            }
        });

        for(int i = 0; i < m; i++){
            System.out.print(list.get(i) + " ");
        }
    }
}
