#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>

using namespace std;

bool comp(pair<long long, int> p1, pair<long long, int> p2)
{
    return p1.first > p2.first;
}

int main()
{
    int n;
    cin >> n;
    int* masA = new int[n];
    long long* masCount = new long long[n];
    map<int, vector<long long> > mp;
    for(int i = 0; i < n-1; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        mp[a].push_back(b);
        mp[b].push_back(a);
    }

    for(int i = 0; i < n; i++){
        cin >> masA[i];
        masCount[i] = 0;
    }

    for(int i = 0; i < n; i++){
        for(int j = 0; j < mp[i].size(); j++){
            masCount[i] += masA[mp[i][j]];
        }
    }

    long long maxX = 0;

    for(int i = 0; i < n; i++){
        long long ansFo = 0;

        for(int j = 0; j < mp[i].size(); j++){
            ansFo += masCount[mp[i][j]] - masA[i];
        }


        maxX = max(maxX, ansFo);
    }

    cout << maxX;
}