#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<pair<int, ll> > >g;
vector<bool>used;
map<int,int>x;
vector<ll>dp1, dp2;

const ll inf = 1e18;

int n, m, q;

void dfs(int v, int c){
    if(v == 0 || v == n - 1){
        return;
    }
    x[v] = c;
    used[v] = 1;
    for(auto to : g[v]){
        if(!used[to.second]){
            dfs(to.second, c);
        }
    }
}

void dfs1(int v){
    if(v == n - 1){
        return;
    }
    for(auto to : g[v]){
        if(dp1[to.second] == inf){
            dp1[to.second] = dp1[v] + to.first;
            dfs1(to.second);
        }
    }
}

void dfs2(int v){
    if(v == 0){
        return;
    }
    for(auto to : g[v]){
        if(dp2[to.second] == inf){
            dp2[to.second] = dp2[v] + to.first;
            dfs2(to.second);
        }
    }
}

void dka(int s, vector<ll>&d){
    d[s] = 0;
    priority_queue<pair<ll, int> >q;
    q.push({0, s});
    while(!q.empty()){
        ll l = -q.top().first; int v = q.top().first;
        cout << l << ' ' << v << endl;
        if(l > d[v]){
            continue;
        }
        q.pop();
        for(int i = 0; i < g[v].size(); i++){
            int to = g[v][i].first;
            if(d[v] + g[v][i].second < d[to]){
                d[to] = d[v] + g[v][i].second;
                q.push({-d[to], to});
            }
        }
    }
}

void dka1(int s, vector<ll>&d){
    d[s]=0;
    priority_queue<pair<ll,int> >q;
    q.push(make_pair(0,s));
    while(!q.empty()){
        ll l=-q.top().first;
        int v=q.top().second;
        q.pop();
        if(l>d[v])
            continue;
        for(int i=0;i<g[v].size();i++){
            int pot=g[v][i].second;
            if(d[v]+g[v][i].first<d[pot]) {
                d[pot]=d[v]+g[v][i].first;
                q.push(make_pair(-d[pot],pot));
            }
        }
    }
}

int main()
{
    cin >> n >> m >> q;
    vector<ll>d(n, inf); g.resize(n); vector<ll>d1(n, inf); used.resize(n);
    dp1.resize(n, inf); dp2.resize(n, inf);
    for(int i = 0; i < m; i++){
        int a, b;
        ll w;
        cin >> a >> b >> w;
        g[a - 1].push_back({w, b - 1});
        g[b - 1].push_back({w, a - 1});
    }
    dka1(0, d);
    dka1(n - 1, d1);
    used[0] = 1; used[n - 1] = 1;
    int c = 1;
    for(int i = 1; i < n; i++){
        if(!used[i]){
            dfs(i, c);
            c++;
        }
    }
    dfs1(0);
    dfs2(n - 1);
    for(int i = 0; i < q; i++){
        int a, b;
        cin >> a >> b;
        a--, b--;
        if(x[a] == x[b] && !x[a]){
            cout << d[b] << ' ';
        }
        else if(x[a] != x[b]){
            cout << min(d[a] + d[b], d1[a] + d1[b]) << ' ';
        }
        else{
            if(dp1[b] < dp1[a]){
                cout << min(dp1[a] - dp1[b], dp2[b] - dp2[a]) << ' ';
            }
            else{
                cout << min(dp2[a] - dp2[b], dp1[b] - dp1[a]) << ' ';
            }
        }
    }
}
