// улк 423 - 2

#include <bits/stdc++.h>

#define pb push_back
#define F first
#define S second

using namespace std;
using ll = long long;
using ld = long double;
using pi = pair<int, int>;
using vi = vector<int>;
using vpi = vector<pi>;

const int INF = 1e9+7;
const ll LINF = 1e18;

const int N = 1e5+7;
int n, m, q, color[N];
ll a[N], b[N];
vpi g[N];

void dfs_a(int v, int t, int p = -1) {
    if(v == n - 1) return; color[v] = t;
    for(pi x : g[v]) {
        const int to = x.F, cost = x.S;
        if(to != p) a[to] = min(a[to] ? a[to] : LINF, a[v] + cost), dfs_a(to, t, v);
    }
}

void dfs_b(int v, int t, int p = -1) {
    if(v == 0) return;
    for(pi x : g[v]) {
        const int to = x.F, cost = x.S;
        if(to != p) b[to] = min(b[to] ? b[to] : LINF, b[v] + cost), dfs_b(to, t, v);
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m >> q;
    while(m--) {
        int a, b, c; cin >> a >> b >> c;
        g[a-1].pb({b-1, c}), g[b-1].pb({a-1, c});
    }

    for(int i = 0; i < g[0].size(); ++i)
        a[g[0][i].F] = g[0][i].S, dfs_a(g[0][i].F, i+1, 0);
    for(int i = 0; i < g[n-1].size(); ++i)
        b[g[n-1][i].F] = g[n-1][i].S, dfs_b(g[n-1][i].F, i+1, n-1);

    //for(int i = 0; i < n; ++i) cout << i+ 1 << ' '; cout << endl;
    //for(int i = 0; i < n; ++i) cout << a[i] << ' '; cout << endl;
    //for(int i = 0; i < n; ++i) cout << b[i] << ' '; cout << endl;
    //for(int i = 0; i < n; ++i) cout << color[i] << ' '; cout << endl;

    while(q--) {
        int va, vb; cin >> va >> vb; va--; vb--; if(va > vb) swap(va, vb);
        if(va == 0) cout << min(a[vb], b[0] + b[vb]) << ' ';
        else if(vb == n-1) cout << min(b[va], a[va] + b[0]) << ' ';
        else {
            ll res = color[va] == color[vb] ? abs(a[va] - a[vb]) : LINF;
            res = min(res, a[va] + a[vb]);
            res = min(res, b[va] + b[vb]);
            res = min(res, a[va] + b[vb] + b[0]);
            res = min(res, b[va] + a[vb] + b[0]);
            cout << res << ' ';
        }
    }
    cout << endl;
}
