#include <bits/stdc++.h>

#define pb push_back
#define F first
#define S second

using namespace std;
using ll = long long;
using vi = vector<int>;

const int N = 1e5+7;

int n, a[N];
ll b[N];
vi g[N];

void dfs(int v, int p = -1) {
    for(int to : g[v])
        if(to != p) dfs(to, v), b[v] += a[to];
    if(p >= 0) b[v] += a[p];
}

ll solve(int v, int p = -1) {
    ll res = 0;
    for(int to : g[v])
        res += b[to] - a[v];
    for(int to : g[v]) if(g[to].size() < 2) res = 0;
    //cout << v << " => " << res << endl;
    for(int to : g[v])
        if(to != p) res = max(res, solve(to, v));
    return res;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n;
    for(int i = n; --i; ) {
        int a, b; cin >> a >> b;
        g[a-1].pb(b-1);
        g[b-1].pb(a-1);
    }
    for(int i = 0; i < n; ++i) cin >> a[i];
    dfs(0); cout << solve(0) << endl;
}
