#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <deque>
#include <string>

using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	int n, k;
	string s;
	char c;
	cin >> n;
	deque<int> floors;
	deque<bool> oks;
	bool ok = true;
	for (int l = 0; l < n; l++) {
		cin >> c >> s;
		bool plus = c == '+';
		bool top = s[0] == 't';
		if (plus) {
			cin >> k;
			if (top) {
				floors.push_back(k);
				if (floors.size() > 1) {
					oks.push_back((floors[floors.size() - 2] == k - 1) && oks.back());
				}
				else oks.push_back(true);
			}
			else {
				floors.push_front(k);
				if (floors.size() > 1) {
					oks.push_front((floors[1] == k + 1) && oks[0]);
				}
				else oks.push_back(true);
			}
			if (oks.back() && oks[0]) cout << "YES"; else cout << "NO";
		}
		else {
			bool flag = false;
			if (top) {
				floors.pop_back();
				if (oks.size() > 1) {
					if (oks.back() && !oks[oks.size() - 2])
						flag = true;
				}
				else flag = true;
				oks.pop_back();
			}
			else {
				floors.pop_front();
				if (oks.size() > 1) {
					if (oks[0] && !oks[1])
						flag = true;
				}
				else flag = true;
				oks.pop_front();
			}
			if (flag) {
				oks[0] = true;
				for (int i = 1; i < floors.size(); i++) {
					if (floors[i] == floors[i - 1] + 1) {
						oks[i] = oks[i - 1];
					}
				}
			}
			if (floors.size() == 0) cout << "NO"; else
			if (oks.back()) cout << "YES"; else cout << "NO";
		}
		cout << '\n';
	}
	return 0;
}
