#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	int n, x, y;
	cin >> n;
	vector<vector<int>> towns(n);
	vector<bool> allowed(n, true);
	vector<int> people(n);
	for (int i = 0; i < n - 1; i++) {
		cin >> x >> y;
		x--;
		y--;
		towns[x].push_back(y);
		towns[y].push_back(x);
	}
	for (int i = 0; i < n; i++)
	{
		cin >> people[i];
		if (towns[i].size() == 1) {
			allowed[towns[i][0]] = false;
		}
	}
	long long max_value = 0;
	for (int i = 0; i < n; i++) {
		if (!allowed[i]) continue;
		long long value = 0;
		for (auto j : towns[i]) {
			for (auto k : towns[j]) {
				if (i == k) continue;
				value += people[k];
			}
		}
		max_value = max(value, max_value);
	}
	cout << max_value;
	return 0;
}