#include <iostream>

using namespace std;

int inf = 1000000;

pair<int, int> query(int x, int y) {
	cout << x << " " << y << endl;
	int dx, dy;
	cin >> dx >> dy;
	return {dx, dy};
}

int main(){
	int dx = 0, dy = 0;
	int lx = -inf, rx = inf, ly = -inf, ry = inf;
	int ansx = 2000*inf, ansy = 2000*inf;
	while (rx - lx > 1) {
		int m = (lx + rx) / 2;
		pair<int, int> d = query(m + dx, 0);
		if (d.first == 0 && d.second == 0)
			return 0;
		dx += d.first;
		dy += d.second;
		if (d.first < 0)
			rx = m;
		else if (d.first > 0)
			lx = m;
		else {
			ansx = m;
			break;
		}
	}
	if (ansx == 2000*inf) {
		pair<int, int> d = query(lx + dx, 0);
		if (d.first == 0 && d.second == 0)
			return 0;
		dx += d.first;
		dy += d.second;
		if (d.first == 0)
			ansx = lx;
		else
			ansx = rx;
	}
	
	while (ry - ly > 1) {
		int m = (ly + ry) / 2;
		pair<int, int> d = query(0, m + dy);
		if (d.first == 0 && d.second == 0)
			return 0;
		dx += d.first;
		dy += d.second;
		if (d.second < 0)
			ry = m;
		else if (d.second > 0)
			ly = m;
		else {
			ansy = m;
			break;
		}
	}
	if (ansy == 2000*inf) {
		pair<int, int> d = query(0, ly + dy);
		if (d.first == 0 && d.second == 0)
			return 0;
		dx += d.first;
		dy += d.second;
		if (d.second == 0)
			ansy = ly;
		else
			ansy = ry;
	}
	
	query(ansx + dx, ansy + dy);
	return 0;
}