#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>

using namespace std;

bool comp(pair<long long, int> p1, pair<long long, int> p2)
{
    return p1.first > p2.first;
}

int main()
{
    long long n;
    cin >> n;
    long long* masA = new long long[n];
    long long* masCount = new long long[n];
    map<long long, vector<long long> > mp;
    for(long long i = 0; i < n-1; i++){
        long long a, b;
        cin >> a >> b;
        a--;
        b--;
        mp[a].push_back(b);
        mp[b].push_back(a);
    }

    for(long long i = 0; i < n; i++){
        cin >> masA[i];
        masCount[i] = 0;
    }

    for(long long i = 0; i < n; i++){
        for(long long j = 0; j < mp[i].size(); j++){
            masCount[i] += masA[mp[i][j]];
        }
    }

    long long maxX = 0;

    for(long long i = 0; i < n; i++){
        long long ansFo = 0;

        for(long long j = 0; j < mp[i].size(); j++){
            ansFo += masCount[mp[i][j]] - masA[i];
        }


        maxX = max(maxX, ansFo);
    }

    cout << maxX;
}
/*
9
user9 147 School2
user1 1000 School1
user5 200 School3
user3 700 School1
user8 0 School2
user4 800 School1
user2 500 School2
user6 1500 School2
user7 251 School2
*/
/*

*/

/*
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>

using namespace std;

bool comp(pair<string, int> p1, pair<string, int> p2)
{
    return p1.second > p2.second;
}

int main()
{
    long long n;
    cin >> n;
    map<string, int> cnt;
    map<string, int> scr;
    for (int i = 0; i < n; ++i)
    {
        string u, sch;
        int sc;
        cin >> u >> sc >> sch;

        if (cnt.find(sch) != cnt.end())
        {
            cnt[sch] = 1;
            scr[sch] = sc;
        }
        else
        {
            cnt[sch] += 1;
            scr[sch] += sc;
        }
    }

    vector<pair<string, int> > out(n);
    map<string, int>::iterator it = cnt.begin();
    for (it; it < cnt.end(); it++)
    {
        if ((*it).second >= 3)
        {
            out.push_back(pair<string, int>((*it).first, scr[(*it).first]));
        }
    }

    sort(out.begin(), out.end(), &comp);
    cout << 2;

    for (pair<string, int> p : out)
    {
        cout << p.first << "\n";
    }
}
*/
