#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>

using namespace std;

//423_8

int main()
{
    long long n;
    cin >> n;
    long long* masA = new long long[n];
    long long* masCount = new long long[n];
    map<long long, vector<long long> > mp;
    for(int i = 0; i < n; i++){
        mp[i] = vector<long long>();
    }
    for(long long i = 0; i < n-1; i++){
        long long a, b;
        cin >> a >> b;
        a--;
        b--;
        mp[a].push_back(b);
        mp[b].push_back(a);
    }

    for(long long i = 0; i < n; i++){
        cin >> masA[i];
        masCount[i] = 0;
    }

    for(long long i = 0; i < n; i++){
        for(long long j = 0; j < mp[i].size(); j++){
            masCount[i] += masA[mp[i][j]];
        }
    }

    long long maxX = 0;

    for(long long i = 0; i < n; i++){
        long long ansFo = 0;

        for(long long j = 0; j < mp[i].size(); j++){
            ansFo += masCount[mp[i][j]] - masA[i];
        }


        maxX = max(maxX, ansFo);
    }

    cout << maxX;
}
