#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define dou long double
#define fi first
#define se second

#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define allv(v) v.begin(), v.end()

#define deb if(debug)

int debug = 0;

vector <vector <pair <ll, ll>>> g;
vector <pair <ll, ll>> dist, distp;
vector <ll> dug;

int main()
{
    if(!debug) ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    ll n, m, q;
    cin >> n >> m >> q;
    g.resize(n+1);
    dist.resize(n+1, {(ll)1e18+1, (ll)1e18+1});
    dug.resize(n+1);
    dug[1] = -1;
    ll C1, C2, d;
    for(int i = 0; i < m; ++i){
        cin >> C1 >> C2 >> d;
        g[C1].pb({C2, d});
        g[C2].pb({C1, d});
    }
    dist[1] = {0, (ll)1e18+1};
    dist[n] = {(ll)1e18+1, 0};
    for(int i = 0; i < g[1].size(); ++i){
        ll p = 1, now = g[1][i].fi, ans = g[1][i].se;
        while(now != n){
			dist[now].fi = ans;
			dug[now] = i+1;
			pair <ll, ll> nxt;
            if(g[now][0].fi == p)
				nxt = g[now][1];
			else
				nxt = g[now][0];
			ans += nxt.se;
			p = now;
			now = nxt.fi;
        }
        dist[1].se = min(dist[1].se, ans);


    }

    for(int i = 0; i < g[n].size(); ++i){
		ll p = n, now = g[n][i].fi, ans = g[n][i].se;
		while(now != 1){
			dist[now].se = ans;
			pair <ll, ll> nxt;
            if(g[now][0].fi == p)
				nxt = g[now][1];
			else
				nxt = g[now][0];
			ans += nxt.se;
			p = now;
			now = nxt.fi;
        }
        dist[n].fi = min(dist[n].fi, ans);
    }

    distp = dist;

    for(int i = 2; i < n; ++i)
		if(dist[i].fi < dist[i].se)
			dist[i].se = min(dist[i].se, dist[i].fi + dist[1].se);
		else
			dist[i].fi = min(dist[i].fi, dist[i].se + dist[1].se);

    deb for(int i = 1; i <= n; ++i)
		cout << dist[i].fi << " " << dist[i].se << '\n';

	while(q--){
		cin >> C1 >> C2;
		if(dug[C1] != dug[C2])
			cout << min(dist[C1].fi + dist[C2].fi, dist[C1].se + dist[C2].se) << " ";
		else
			cout << min(abs(distp[C1].fi - distp[C2].fi), min(dist[C1].fi + dist[C2].fi, dist[C1].se + dist[C2].se)) << " ";
	}

    return 0;
}
