#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define dou long double
#define x first
#define y second

#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define allv(v) v.begin(), v.end()

#define deb if(debug)

int debug = 0;
vector<pair<ll,ll>> tree;
void ob(ll g,int i)
{
    tree[i].x -= g;
    tree[i].y -= g;
    i/=2;
    while(i>0)
    {
        tree[i].x = min(tree[2*i].x, tree[2*i+1].x);
        tree[i].y = max(tree[2*i].y, tree[2*i+1].y);
        i/=2;
    }
}

void ob2(ll g,int i)
{
    tree[i].x = g;
    tree[i].y = g;
    i/=2;
    while(i>0)
    {
        tree[i].x = min(tree[2*i].x, tree[2*i+1].x);
        tree[i].y = max(tree[2*i].y, tree[2*i+1].y);
        i/=2;
    }
}

bool prov(int l,int r)
{
    ll m1 = tree[l].x, m2 = tree[l].y;
    for(;l<=r;l/=2,r/=2)
    {
        if(l%2 == 1)
        {
            m1 = min(m1, tree[l].x);
            m2 = max(m2, tree[l].y);
            l++;
        }
        if(r%2 == 0)
        {
            m1 = min(m1, tree[r].x);
            m2 = max(m2, tree[r].y);
            r--;
        }
    }
    return m1 == m2;
}

int main()
{
   // ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    int l = n+2,r= n+2;
    int m = 2*n+4;
    tree.resize(m*2);
    for(int i=0;i<m;i++)
    {
        tree[i+m] = {i,i};
    }
    for(int i=m-1;i>0;i--)
    {
        tree[i].x = min(tree[2*i].x, tree[2*i+1].x);
        tree[i].y = max(tree[2*i].y, tree[2*i+1].y);
    }
    for(int i=0;i<n;i++)
    {
        char c;
        cin >> c;
        if(c == '+')
        {
            string s;
            ll h;
            cin >> s >> h;
            if(s == "top")
            {
                ob(h, r+m);
                r++;
            }
            else
            {
                l--;
                ob(h,l+m);
            }
        }
        else
        {
            string s;
            cin >> s;
            if(s == "top")
            {
                r--;
                ob2((ll)r, r+m);

            }
            else
            {
                ob2((ll)l,l+m);
                l++;
            }
        }
        for(int i=0;i<m;i++)
        {
            cout << tree[i+m].x << ' ';
        }
        cout << "\n";
        if(prov(l+m,r+m-1) && l != r)
            cout << "YES\n";
        else
            cout << "NO\n";
    }
    return 0;
}
