#include <iostream>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <vector>
#include <utility>
#include <cmath>
#include <iomanip>
#define F first
#define S second
#define eb emplace_back

using namespace std;

const int N = 2e5+5;
const long long INF = 1e18;

long long n, m, q, a, b, c, david, lead[N], dl[N], dr[N], k;

vector<pair<int,long long>> g[N];

void dfs1(int v, int p, int mn){
    if(v==n) return;
    lead[v] = mn;
    for(const auto& to: g[v]){
        if(to.F==p) continue;
        dl[to.F] = dl[v]+to.S;
        dfs1(to.F,v,mn);
    }
}
void dfs2(int v, int p){
    if(v==1) return;
    for(const auto& to: g[v]){
        if(to.F==p) continue;
        dr[to.F] = dr[v]+to.S;
        dfs2(to.F,v);
    }
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> q;
    for(int i = 0; i < m; ++i){
        cin >> a >> b >> c;
        g[a].eb(b,c);
        g[b].eb(a,c);
    }
    for(const auto& to: g[1]){
        dl[to.F] = to.S;
        dfs1(to.F,1,++k);
    }
    david = INF;
    for(const auto& to: g[n]){
        david = min(david,dl[to.F]+to.S);
    }
    dfs2(n,-1);
    while(q--){
        cin >> a >> b;
        long long res = INF;
        if(lead[a]==lead[b]) res = dl[b]-dl[a];
        res = min(res,min(min(dl[a]+dl[b],dr[a]+dr[b]),min(dl[a]+dr[b]+david,dl[b]+dr[a]+david)));
        cout << res << " ";
    }
    return 0;
}
