#include <iostream>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <vector>
#include <utility>
#define F first
#define S second

using namespace std;

const int N = 2e5+5;

long long n, a, b, sumd[N], p[N], d[N], ans;
vector<int> g[N];

void predfs(int v){
    for(int to: g[v]){
        if(to==p[v]) continue;
        p[to] = v;
        sumd[v]+=d[to];
        predfs(to);
    }
}
void dfs(int v){
    bool ok = true;
    long long res = -d[v];
    if(!p[v]) res = 0;
    for(int to: g[v]){
        if(g[to].size()==1) ok = false;
        if(to==p[v]) continue;
        res+=sumd[to];
        dfs(to);
    }
    res+=sumd[p[v]]+d[p[p[v]]];
    if(ok&&res>ans) ans = res;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n-1; ++i){
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for(int i = 1; i <= n; ++i)
        cin >> d[i];
    predfs(1);
    dfs(1);
    cout << ans;

    return 0;
}
