#include <iostream>
#include <iomanip>
#include <cmath>
#include <limits>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;

int main()
{
    int64_t out_x_left = -1e9, out_x_right = 1e9, out_y_left = -1e9, out_y_right = 1e9, in_x, in_y;
    while (!(in_x == 0 && in_y == 0))
    {
        int64_t mid_x = (out_x_left + out_x_right) / 2;
        int64_t mid_y = (out_y_left + out_y_right) / 2;
        cout << mid_y << " " << mid_x << endl;
        cin >> in_y >> in_x;
        if ((in_y > 0) && (in_x > 0))
        {
            out_y_left = mid_y;
            out_x_left = mid_x;
        }
        else if ((in_y > 0) && (in_x < 0))
        {
            out_y_left = mid_y;
            out_x_right = mid_x;
        }
        else if ((in_y < 0) && (in_x > 0))
        {
            out_y_right = mid_y;
            out_x_left = mid_x;
        }
        else if ((in_y < 0) && (in_x < 0))
        {
            out_y_right = mid_y;
            out_x_right = mid_x;
        }
    }
    return 0;
}