#include <iostream>

using namespace std;

pair<int, int> answer(int x, int y) {
    cout << x << " " << y << "\n";
    cout.flush();
    int dx, dy;
    cin >> dx >> dy;
    return make_pair(dx, dy);
}

int main()
{
    const int edge = 1e9;

    auto p = answer(0, 0);
    bool lockX = false, lockY = false;
    int lockedX, lockedY;
    if(p.first == 0) {
        lockX = true;
        lockedX = 0;
    }
    if(p.second == 0) {
        lockY = true;
        lockedY = 0;
    }
    int lx = 0, rx = 0, ly = 0, ry = 0;

    if(p.first == 1) {
        rx = edge;
    } else {
        lx = -edge;
    }

    if(p.second == 1) {
        ry = edge;
    } else {
        ly = -edge;
    }

    while(!lockX && !lockY) {
        int dx, dy;
        if(!lockX) {
            dx = (rx + lx) / 2;
        } else {
            dx = lockedX;
        }

        if(!lockY) {
            dy = (ry + ly) / 2;
        } else {
            dy = lockedY;
        }

        p = answer(dx, dy);
        if(p.first == 0) {
            lockX = true;
            lockedX = dx;
        }
        if(p.second == 0) {
            lockY = true;
            lockedY = dy;
        }

        if(p.first == 1) {
            lx = dx;
            rx++;
        } else {
            rx = dx;
            lx--;
        }

        if(p.second == 1) {
            ly = dy;
            ry++;
        } else {
            ry = dy;
            ly--;
        }
    }
}
