// УЛК 423_2

#include <bits/stdc++.h>

#define pb push_back
#define F first
#define S second

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;
using vpi = vector<pi>;

const ld PI = 4*atan((ld)1);
const ld EPS = 1e-8;
const int INF = 1e9;

using seg = pair<pi, pi>;
using hol = pair<pi, pi>;

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n; cin >> n; vpi queries; vector<hol> holes;
    int planets = 0, hholes = 0;
    while(n--) {
        int t; cin >> t;
        if(t == 1) {
            int x; cin >> x; queries.pb({x, planets++});
        }
        else {
            int x, p, w; cin >> x >> p >> w;
            holes.pb({{x, ++hholes}, {p, w}});
        }
    }

    cout << planets << endl;

    sort(holes.begin(), holes.end());
    sort(queries.begin(), queries.end());

    vector<pair<ll, int>> v(queries.size(), { -INF, -1 });
    priority_queue<pair<ll, int>> q;

    for(int i = 0, j = 0; i < queries.size(); ++i) {
        const int x = queries[i].F;
        while(j < holes.size() && holes[j].F.F <= x) q.push({(ll)holes[j].S.F + holes[j].F.F, j}), ++j;
        //cout << x << ", " << q.size() << endl;
        while(!q.empty() && (ll)holes[q.top().S].F.F + holes[q.top().S].S.S < x) q.pop();
        //cout << q.size() << endl;
        if(!q.empty() && v[queries[i].S].F < q.top().F - x) v[queries[i].S] = { q.top().F - x, holes[q.top().S].F.S };
    }

    //for(pi x : v) cout << x.S << ' '; cout << endl;

    while(!q.empty()) q.pop();

    for(int i = queries.size(), j = holes.size() - 1; i--; ) {
        const int x = queries[i].F;
        while(j >= 0 && holes[j].F.F >= x) q.push({(ll)holes[j].S.F - holes[j].F.F, j}), --j;
        while(!q.empty() && (ll)holes[q.top().S].F.F - holes[q.top().S].S.S > x) q.pop();
        //cout << q.size() << endl;
        if(!q.empty() && v[queries[i].S].F < q.top().F + x) v[queries[i].S] = { x + q.top().F, holes[q.top().S].F.S };
    }

    for(pair<ll, int> x : v) cout << x.S << ' '; cout << endl;
}
