#include <bits/stdc++.h>

#define pb push_back
#define F first
#define S second

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;

const ld PI = 4*atan((ld)1);

ld norm(ld x) {
    //cout << x << ": ";
    while(x > PI) x -= PI;
    while(x < -PI) x += PI;
    //cout << x << endl;
    return x;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    ld k, x0, y0;
    cin >> x0 >> y0 >> k;
    ld d = 1 + 4*k*k*(x0*x0+y0*y0);
    ld x = sqrt((-1 + sqrt(d)) / 2 / k / k);
    ld y = k * x * x;
    ld phi = atan2(y0, x0);
    ld gamma = atan2(y, x);
    //cout << phi << ' ' << gamma << endl;
    cout << setprecision(9) << fixed << (y0 < k*x0*x0 ? min(abs(norm(phi - gamma)), abs(norm(gamma - phi))) : 0);
}
