#include <bits/stdc++.h>

#define pb push_back
#define F first
#define S second

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;

const ld PI = 4*atan((ld)1);
const ld EPS = 1e-8;

ld norm(ld x) {
    //cout << x << ": ";
    while(x > PI/2) x -= PI;
    while(x < -PI/2) x += PI;
    //cout << x << endl;
    return x;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    ld k, x0, y0;
  //  cout << atan2(sqrt(3.0), 1) << endl;

    cin >> x0 >> y0 >> k; x0 = abs(x0); x0 *= k, y0 *= k;
    ld d = 1 + 4*(x0*x0+y0*y0);
    ld x = sqrt((-1 + sqrt(d)) / 2);
    ld phi = norm(atan2(y0, x0));
    ld gamma = atan(x);
   // cout << phi << ' ' << gamma << endl;
    cout << setprecision(9) << fixed << (y0+EPS < x0*x0 ? gamma - phi : 0);
}
