#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
const int N = 1e5 + 500;

ll ans1[N], ans2[N];
ll a[N];
bool valid[N];
vector <int> g[N];

#define F first
#define S second
#define PB push_back
#define sz(v) (int)v.size()
#define all(v) v.begin(),v.end()

void dfs(int v,int p1 = -1,int p2 = -1){
    if(p1 > 0){
        ans1[p1] += a[v];
        ans1[v] += a[p1];
    }
    if(p2 > 0) ans2[p2] += a[v];
    //cout<<v<<' '<<p1<<' '<<p2<<endl;
    for(auto e:g[v]){
        if(e == p1) continue;
        dfs(e,v,p1);
    }
}

void dfs2(int v,int p1 = -1,int p2 = -1){
    if(p1 > 0) ans2[v] += ans1[p1] - a[v];
    for(auto e:g[v]){
        if(e == p1) continue;
        dfs2(e,v,p1);
    }
}


int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout<<fixed<<setprecision(20);
    int n; cin>>n;
    for(int i=1;i<n;i++){
        int a,b; cin>>a>>b;
        g[a].PB(b);
        g[b].PB(a);
    }
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }
    dfs(1);
    dfs2(1);
    for(int i=1;i<=n;i++){
        if(sz(g[i]) == 1){
            for(auto e:g[i]) valid[e] = 1;
        }
    }
    ll an = 0;
    for(int i=1;i<=n;i++){
        if(!valid[i]){
            an = max(an,ans2[i]);
        }
        //cout<<i<<' '<<ans2[i]<<' '<<ans1[i]<<endl;
    }
    cout<<an<<endl;
    return 0;
}
