#include <iostream>
#include <cmath>

using namespace std;

int main() {
    double x0, y0, k;
    cin >> x0 >> y0 >> k;
    if(y0 >= k * x0 * x0) {
        cout << '0' << endl;
    }
    else {
        x0 = abs(x0);
        double r_sq = x0 * x0 + y0 * y0;
        double y1 = (-1 + sqrt(1 + 4 * k * k * r_sq))/(2 * k);
        double x1 = sqrt(y1 / k);
        double angle = acos((x0 * x1 + y0 * y1) / r_sq);
    	cout.precision(20);
        cout << angle << endl;
    }
    return 0;
}
